//+------------------------------------------------------------------+
//|                                           Send_Pending_Order_lines.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "komposter"
#property link      "mailto:komposterius@mail.ru"
/*
-----------------------------Please note---------------------------------
I strongly recommend to study the following instruction before you use tis script:

This script is placing pending order.
And it is necessary to do the following:
 1) Read this instruction :), set all the settings by default(you will see the default settings below this instruction and 
 the settings are started and finished by this line
   //+----------------------------------------------+ ),
  "Allow external experts imports" should be enable:
    "Tools" -> "Options" -> "Expert Advisors" -> "Allow external experts imports"
  (it is necessary to describe the errors which may be during the orders placing)
 2) Attach script to the chart. Please note that the place of attaching is exact price of openning (OpenPrice).
  It is possible to change this price during the placing, but I recommend you
  to attach script to the level of order openning.
 3) Move all the lines on the necessary levels:
- Open_Price_Line (by default - in white color) - price to place the order  (should be a line)
- Stop_Loss_Line (red) - Stop Loss level (necessarily)
- Take_Profit_Line (green) - Take Profit level (unnecessarily)
- Expiration_Line (yellow) - Expiry (unnecessarily)
(you may delete unnecessarily lines)
- "````" - lot size. (from 0,1 to 10 lots)
The Type of the order is selected in depends of location of Open_Price and Stop_Loss lines:
Open_Price  >  Bid and Open_Price  >  Stop_Loss  -  BUYSTOP-order,
Open_Price  >  Bid and Open_Price  <  Stop_Loss  -  SELLLIMIT-order,
Open_Price  <  Ask and Open_Price  >  Stop_Loss  -  BUYLIMIT-order,
Open_Price  <  Ask and Open_Price  <  Stop_Loss  -  SELLSTOP-order.
 4) When everything is ready so just click "OK" on the window appeared.
 
 
 If you find the bug or have some suggestion on how to improve it please send the message to komposterius@mail.ru
*/
//+------------------------------------------------------------------+
// All the settings described below you may change in script options window during the attaching it to the chart.
// It is usefull to select the lot size for example. 
// If you do not need script options window so just comment the following line (place // in the beginning of the line)
#property show_inputs


// Order type by default
extern int _OrderType = 1; //( "1" - BUYSTOP or BUYLIMIT, "-1" - SELLSTOP or SELLLIMIT )

// Default interval in pips between Take_Profit/Stop_Loss and Open_Price lines.
// If you don't use Take_Profit so set the value to 0
extern int Stop_Loss = 300;
extern int Take_Profit = 300;
extern int RiskPercent = 2.0;

// Slippage
extern int Slippage = 5;

// Comments
extern string _Comment = "Opened by Pend Mouse Script";

// Order ID
extern int MagicNumber = 0;

// Expiration order time
// Hor H4 and Expiration_Shift = 3 expiration time is 12 hours
// If you need standard expiration time for all the timeframes so set as "0" (without quotation marks) and go to the following settings
// If you don't need expiration set to 0
extern int Expiration_Shift = 0;
// Expiration order time in hours
// To use this option you need to set Expiration_Shift as "0" (without quotation marks)
// If you don't need expiration set to 0
extern int Expiration_Shift_H = 1;

extern string Order_Color = "----------------------------------------------------------------------------------------";
// Colors
extern color Buy_Color = Lime; //( for BUYSTOP and BUYLIMIT )
extern color Sell_Color = Red; //( for SELLLIMIT and SELLSTOP )

extern string Line_Color = "----------------------------------------------------------------------------------------";
// Colors of the lines:
extern color Open_Price_Line_Color = White;
extern color Stop_Loss_Line_Color = Red;
extern color Take_Profit_Line_Color = Lime;
extern color Expiration_Line_Color = Yellow;

double pipValue = MarketInfo(Symbol(),MODE_TICKVALUE) ;
//+------------------------------------------------------------------+

#include <stdlib.mqh>
int first = 1;
int start()
{
//+------------------------------------------------------------------+      Please check here
double Lots = AccountBalance()*(RiskPercent/100.0)/(Stop_Loss*pipValue);

int norm = 0;
Lots = NormalizeDouble(Lots,norm);

//double actualRisk; 

string comment = +"\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n"+ DoubleToStr(Stop_Loss/10,0)+" SL "+DoubleToStr(RiskPercent,0)+"% \n\n Lots size = "+DoubleToStr(Lots,norm);
/*
if (lots<minLot)
{
actualRisk = (100*minLot*StopLoss*pipValue)/AccountBalance();
comment = "lot size less than minimal allowed lot for risk and stop loss setting\n"+
"calculated lot size : "+DoubleToStr(lots,norm)+" minimal allowed : "+DoubleToStr(minLot,norm)+"\n" +
"risk with minimal lot size and stop loss set to : "+DoubleToStr(StopLoss,2)+"pips is : "+DoubleToStr(actualRisk,2)+"%" ;
}*/
Comment(comment);


//+===============================                                     To here

double Open_Price_Level, Stop_Loss_Level, Take_Profit_Level;
datetime Expiration_Time;
// ---Open_Price_Level
Open_Price_Level = PriceOnDropped();
if ( Open_Price_Level <= 0 )
{ Open_Price_Level = Bid + MarketInfo( Symbol(), MODE_STOPLEVEL )*Point; }
// ---Stop_Loss_Level
Stop_Loss_Level = Open_Price_Level - Stop_Loss * Point;
// ---Take_Profit_Level
if ( Take_Profit > 0 )
{ Take_Profit_Level = Open_Price_Level + Take_Profit * Point; }

if ( _OrderType == -1 )
{
// ---Open_Price_Level
Open_Price_Level = PriceOnDropped();
if ( Open_Price_Level <= 0 )
{ Open_Price_Level = Ask - MarketInfo( Symbol(), MODE_STOPLEVEL )*Point; }
// ---Stop_Loss_Level
Stop_Loss_Level = Open_Price_Level + Stop_Loss * Point;
// ---Take_Profit_Level
if ( Take_Profit > 0 )
{ Take_Profit_Level = Open_Price_Level - Take_Profit * Point; }
}

// ---Expiration_Time
if ( Expiration_Shift > 0 )
{ Expiration_Time = CurTime() + Period()*60*Expiration_Shift; }
else
{
if ( Expiration_Shift_H > 0 )
{ Expiration_Time = CurTime() + 3600*Expiration_Shift_H; }
}
//+------------------------------------------------------------------+
if ( first == 1 )
{
ObjectCreate( "Open_Price_Line", OBJ_HLINE, 0, 0, Open_Price_Level, 0, 0, 0, 0 );
ObjectSet( "Open_Price_Line", OBJPROP_COLOR, Open_Price_Line_Color );
ObjectSetText( "Open_Price_Line", "Open_Price_Line", 6, "Arial", Open_Price_Line_Color );

ObjectCreate( "Stop_Loss_Line", OBJ_HLINE, 0, 0, Stop_Loss_Level, 0, 0, 0, 0 );
ObjectSet( "Stop_Loss_Line", OBJPROP_COLOR, Stop_Loss_Line_Color );
ObjectSetText( "Stop_Loss_Line", "Stop_Loss_Line", 6, "Arial", Stop_Loss_Line_Color );

if ( Take_Profit_Level > 0 )
{
ObjectCreate( "Take_Profit_Line", OBJ_HLINE, 0, 0, Take_Profit_Level, 0, 0, 0, 0 );
ObjectSet( "Take_Profit_Line", OBJPROP_COLOR, Take_Profit_Line_Color );
ObjectSetText( "Take_Profit_Line", "Take_Profit_Line", 6, "Arial", Take_Profit_Line_Color );
}

if ( Expiration_Time > 0 )
{
ObjectCreate( "Expiration_Line", OBJ_VLINE, 0, Expiration_Time, 0, 0, 0, 0, 0 );
ObjectSet( "Expiration_Line", OBJPROP_COLOR, Expiration_Line_Color );
ObjectSetText( "Expiration_Line", "Expiration_Line", 6, "Arial", Expiration_Line_Color );
}
//+------------------------------------------------------------------+
int Lots_value_y = 30;
switch ( (int)(Lots*10))
{
case 2: Lots_value_y = 45; break;
case 3: Lots_value_y = 60; break;
case 4: Lots_value_y = 75; break;
case 5: Lots_value_y = 90; break;
case 6: Lots_value_y = 105; break;
case 7: Lots_value_y = 120; break;
case 8: Lots_value_y = 135; break;
case 9: Lots_value_y = 150; break;
case 10: Lots_value_y = 165; break;
case 20: Lots_value_y = 180; break;
case 30: Lots_value_y = 195; break;
case 40: Lots_value_y = 210; break;
case 50: Lots_value_y = 225; break;
case 60: Lots_value_y = 240; break;
case 70: Lots_value_y = 255; break;
case 80: Lots_value_y = 270; break;
case 90: Lots_value_y = 285; break;
case 100: Lots_value_y = 300; break;
}
if ( Lots > 10.0 ) Lots_value_y = 315;
int Lots_value_y_start_position = Lots_value_y;

ObjectCreate( "Lots", OBJ_LABEL, 0,0,0,0,0,0,0);
ObjectSet( "Lots", OBJPROP_CORNER, 1);
ObjectSet( "Lots", OBJPROP_XDISTANCE, 1);
ObjectSet( "Lots", OBJPROP_YDISTANCE, 10);
ObjectSetText(  "Lots", "Lots", 10, "Arial", Open_Price_Line_Color);

ObjectCreate( "Lots_value", OBJ_LABEL, 0,0,0,0,0,0,0);
ObjectSet( "Lots_value", OBJPROP_CORNER, 1);
ObjectSet( "Lots_value", OBJPROP_XDISTANCE, 25);
ObjectSet( "Lots_value", OBJPROP_YDISTANCE, Lots_value_y);
ObjectSetText(  "Lots_value", "`````", 10, "Arial", Open_Price_Line_Color);

int y = 25;
for ( double z = 0.1; z <= 1; z += 0.1 )
{
ObjectCreate( DoubleToStr( z, 1 ), OBJ_LABEL, 0,0,0,0,0,0,0);
ObjectSet( DoubleToStr( z, 1 ), OBJPROP_CORNER, 1);
ObjectSet( DoubleToStr( z, 1 ), OBJPROP_XDISTANCE, 1);
ObjectSet( DoubleToStr( z, 1 ), OBJPROP_YDISTANCE, y);
ObjectSetText(  DoubleToStr( z, 1 ), DoubleToStr( z, 1 ), 10, "Arial", Open_Price_Line_Color);
y += 15;
}
y = 160;
for ( z = 1; z <= 10; z ++ )
{
ObjectCreate( DoubleToStr( z, 1 ), OBJ_LABEL, 0,0,0,0,0,0,0);
ObjectSet( DoubleToStr( z, 1 ), OBJPROP_CORNER, 1);
ObjectSet( DoubleToStr( z, 1 ), OBJPROP_XDISTANCE, 1);
ObjectSet( DoubleToStr( z, 1 ), OBJPROP_YDISTANCE, y);
ObjectSetText(  DoubleToStr( z, 1 ), DoubleToStr( z, 1 ), 10, "Arial", Open_Price_Line_Color);
y += 15;
}
ObjectCreate( ">", OBJ_LABEL, 0,0,0,0,0,0,0);
ObjectSet( ">", OBJPROP_CORNER, 1);
ObjectSet( ">", OBJPROP_XDISTANCE, 1);
ObjectSet( ">", OBJPROP_YDISTANCE, 310);
ObjectSetText(  ">", ">10", 10, "Arial", Open_Price_Line_Color);

//  
string Question = "Now to set the order please move the lines on the necessary levels and press return/enter" + 
".";
int  Answer = MessageBox( Question, "Pending order placing", 0x00000001 | 0x00000040 | 0x00040000 );
first = 0;
//     ""  - 
if ( Answer != 1 ) { deinit(); return(0); }
}

//      :

//  
Lots_value_y = ObjectGet( "Lots_value", OBJPROP_YDISTANCE );
if ( Lots_value_y_start_position != Lots_value_y )
{
Lots = 0.1;
if ( Lots_value_y >= 35  && Lots_value_y < 50  ) Lots = 0.2;
if ( Lots_value_y >= 50  && Lots_value_y < 65  ) Lots = 0.3;
if ( Lots_value_y >= 65  && Lots_value_y < 80  ) Lots = 0.4;
if ( Lots_value_y >= 80  && Lots_value_y < 95  ) Lots = 0.5;
if ( Lots_value_y >= 95  && Lots_value_y < 110 ) Lots = 0.6;
if ( Lots_value_y >= 110 && Lots_value_y < 125 ) Lots = 0.7;
if ( Lots_value_y >= 125 && Lots_value_y < 140 ) Lots = 0.8;
if ( Lots_value_y >= 140 && Lots_value_y < 155 ) Lots = 0.9;
if ( Lots_value_y >= 155 && Lots_value_y < 170 ) Lots = 1.0;
if ( Lots_value_y >= 170 && Lots_value_y < 185 ) Lots = 2.0;
if ( Lots_value_y >= 185 && Lots_value_y < 200 ) Lots = 3.0;
if ( Lots_value_y >= 200 && Lots_value_y < 215 ) Lots = 4.0;
if ( Lots_value_y >= 215 && Lots_value_y < 230 ) Lots = 5.0;
if ( Lots_value_y >= 230 && Lots_value_y < 245 ) Lots = 6.0;
if ( Lots_value_y >= 245 && Lots_value_y < 260 ) Lots = 7.0;
if ( Lots_value_y >= 260 && Lots_value_y < 275 ) Lots = 8.0;
if ( Lots_value_y >= 275 && Lots_value_y < 290 ) Lots = 9.0;
if ( Lots_value_y >= 290   ) Lots = 10.0;
}
Lots = NormalizeDouble( Lots, 1 );
// Open_Price
Open_Price_Level = NormalizeDouble( ObjectGet( "Open_Price_Line", OBJPROP_PRICE1 ), MarketInfo( Symbol(), MODE_DIGITS ) );
// Stop_Loss
Stop_Loss_Level = NormalizeDouble( ObjectGet( "Stop_Loss_Line", OBJPROP_PRICE1 ), MarketInfo( Symbol(), MODE_DIGITS ) );
// Take_Profit
Take_Profit_Level = NormalizeDouble( ObjectGet( "Take_Profit_Line", OBJPROP_PRICE1 ), MarketInfo( Symbol(), MODE_DIGITS ) );
// Expiration_Time
Expiration_Time = ObjectGet( "Expiration_Line", OBJPROP_TIME1 );

//   
if ( Open_Price_Level - Bid >= 0 )
{
if ( Open_Price_Level - Stop_Loss_Level > 0 )
{ _OrderType = OP_BUYSTOP; }
else
{ _OrderType = OP_SELLLIMIT; }
}
else
{
if ( Open_Price_Level - Stop_Loss_Level > 0 )
{ _OrderType = OP_BUYLIMIT; }
else
{ _OrderType = OP_SELLSTOP; }
}

color _Color;
//   
if ( _OrderType == OP_BUYLIMIT || _OrderType == OP_BUYSTOP )
{
_Color = Buy_Color;
if ( Open_Price_Level - Stop_Loss_Level < MarketInfo( Symbol(), MODE_STOPLEVEL )*Point )
{
Answer = MessageBox(  "Invalid Stop_Loss_Line (red line)!\n" + 
   "\n" +
   "For BuyLimit and BuyStop - orders it should be BELOW the Open_Price_Line.\n" + 
   "Minimum distance (" + Symbol() + ") - " + DoubleToStr( MarketInfo( Symbol(), MODE_STOPLEVEL ), 0 ) + " points.\n" + 
   "\n\n" +
   "To place once again please press \"Repeat\".\n" +
   "To cancel the placing press \"Cancel\".", "Pending order placing", 0x00000005 | 0x00000030 | 0x00040000 );
if ( Answer == 4 ) { ObjectsRedraw(); start(); }
deinit();
return(-1);
}
if ( Take_Profit_Level - Open_Price_Level < MarketInfo( Symbol(), MODE_STOPLEVEL )*Point && Take_Profit_Level > 0 )
{
Answer = MessageBox(  "Invalid Take_Profit_Line (green line)!\n" + 
   "\n" +
   "For BuyLimit and BuyStop - orders it should be ABOVE Open_Price_Line.\n" + 
   "Minimum distance (" + Symbol() + ") - " + DoubleToStr( MarketInfo( Symbol(), MODE_STOPLEVEL ), 0 ) + " points.\n" + 
   "\n\n" +
   "To place order from the beginning press \"Repeat\".\n" +
   "To cancel the placing press \"Cancel\".", "Pending order placing", 0x00000005 | 0x00000030 | 0x00040000 );
if ( Answer == 4 ) { ObjectsRedraw(); start(); }
deinit();
return(-1);
}
if ( _OrderType == OP_BUYSTOP )
{
if ( Open_Price_Level - Bid < MarketInfo( Symbol(), MODE_STOPLEVEL )*Point )
{
Answer = MessageBox( "Invalid Open_Price_Line (white line)!\n" + 
   "\n" +
   "For BuyStop - order it should be ABOVE the current price.\n" + 
   "Minimum distance (" + Symbol() + ") - " + DoubleToStr( MarketInfo( Symbol(), MODE_STOPLEVEL ), 0 ) + " points.\n" + 
   "\n\n" +
   "To place order from the beginning press \"Repeat\".\n" +
   "To cancel the placing press \"Cancel\".", "Pending order placing", 0x00000005 | 0x00000030 | 0x00040000 );
if ( Answer == 4 ) { ObjectsRedraw(); start(); }
deinit();
return(-1);
}
}
else
{
if ( Bid - Open_Price_Level < MarketInfo( Symbol(), MODE_STOPLEVEL )*Point )
{
Answer = MessageBox( "Invalid Open_Price_Line (white line)!\n" + 
   "\n" +
   "For BuyLimit - order it should be BELOW the current price.\n" + 
   "Minimum distance (" + Symbol() + ") - " + DoubleToStr( MarketInfo( Symbol(), MODE_STOPLEVEL ), 0 ) + " points.\n" + 
   "\n\n" +
   "To place order from the beginning press \"Repeat\".\n" +
   "To cancel the placing press \"Cancel\".", "Pending order placing", 0x00000005 | 0x00000030 | 0x00040000 );
if ( Answer == 4 ) { ObjectsRedraw(); start(); }
deinit();
return(-1);
}
}
}
if ( _OrderType == OP_SELLLIMIT || _OrderType == OP_SELLSTOP )
{
_Color = Sell_Color;
if ( Stop_Loss_Level - Open_Price_Level < MarketInfo( Symbol(), MODE_STOPLEVEL )*Point )
{
Answer = MessageBox(  "Invalid Stop_Loss_Line (red line)!\n" + 
   "\n" +
   "For SellLimit and SellStop - orders it should be ABOVE the Open_Price_Line.\n" + 
   "Minimum distance (" + Symbol() + ") - " + DoubleToStr( MarketInfo( Symbol(), MODE_STOPLEVEL ), 0 ) + " points.\n" + 
   "\n\n" +
   "To place order from the beginning press \"Repeat\".\n" +
   "To cancel the placing press \"Cancel\".", "Pending order placing", 0x00000005 | 0x00000030 | 0x00040000 );
if ( Answer == 4 ) { ObjectsRedraw(); start(); }
deinit();
return(-1);
}
if ( Open_Price_Level - Take_Profit_Level < MarketInfo( Symbol(), MODE_STOPLEVEL )*Point && Take_Profit_Level > 0 )
{
Answer = MessageBox(  "Invalid Take_Profit_Line (green line)!\n" + 
   "\n" +
   "For SellLimit and SellStop - orders it should be BELOW the Open_Price_Line.\n" + 
   "Minimum distance (" + Symbol() + ") - " + DoubleToStr( MarketInfo( Symbol(), MODE_STOPLEVEL ), 0 ) + " points.\n" + 
   "\n\n" +
   "To place order from the beginning press \"Repeat\".\n" +
   "To cancel the placing press \"Cancel\".", "Pending order placing", 0x00000005 | 0x00000030 | 0x00040000 );
if ( Answer == 4 ) { ObjectsRedraw(); start(); }
deinit();
return(-1);
}
if ( _OrderType == OP_SELLLIMIT )
{
if ( Open_Price_Level - Ask < MarketInfo( Symbol(), MODE_STOPLEVEL )*Point )
{
Answer = MessageBox( "Invalid Open_Price_Line (white line)!\n" + 
   "\n" +
   "For SellLimit - order it should be BELOW the current price.\n" + 
   "Minimum distance (" + Symbol() + ") - " + DoubleToStr( MarketInfo( Symbol(), MODE_STOPLEVEL ), 0 ) + " points.\n" + 
   "\n\n" +
   "To place order from the beginning press \"Repeat\".\n" +
   "To cancel the placing press \"Cancel\".", "Pending order placing", 0x00000005 | 0x00000030 | 0x00040000 );
if ( Answer == 4 ) { ObjectsRedraw(); start(); }
deinit();
return(-1);
}
}
else
{
if ( Ask - Open_Price_Level < MarketInfo( Symbol(), MODE_STOPLEVEL )*Point )
{
Answer = MessageBox( "Invalid Open_Price_Line (white line)!\n" + 
   "\n" +
   "For SellStop - order it should be ABOVE the current price.\n" + 
   "Minimum distance (" + Symbol() + ") - " + DoubleToStr( MarketInfo( Symbol(), MODE_STOPLEVEL ), 0 ) + " points.\n" + 
   "\n\n" +
   "To place order from the beginning press \"Repeat\".\n" +
   "To cancel the placing press \"Cancel\".", "Pending order placing", 0x00000005 | 0x00000030 | 0x00040000 );
if ( Answer == 4 ) { ObjectsRedraw(); start(); }
deinit();
return(-1);
}
}
}

if ( Expiration_Time <= CurTime() && Expiration_Time > 0 )
{
Answer = MessageBox(  "Invalid Expiration_Line (yellow line)!\n" + 
   "\n" +
   "Expiration time can not be in past time!\n" + 
   "\n\n" +
   "To place order from the beginning press \"Repeat\".\n" +
   "To cancel the placing press \"Cancel\".", "Pending order placing", 0x00000005 | 0x00000030 | 0x00040000 );
if ( Answer == 4 ) { ObjectsRedraw(); start(); }
deinit();
return(-1);
}

//        
Print( "Symbol=",Symbol(), ",_OrderType=",_OrderType, ",Lots=",Lots, ",Open_Price_Level=",Open_Price_Level, ",Slippage=", Slippage, ",Stop_Loss_Level=", Stop_Loss_Level, ",Take_Profit_Level=", Take_Profit_Level, ",_Comment=", _Comment, ",MagicNumber=", MagicNumber, ",Expiration_Time=", Expiration_Time, ",_Color=", _Color );
int ordersend = OrderSend( Symbol(), _OrderType, Lots, Open_Price_Level, Slippage, Stop_Loss_Level, Take_Profit_Level, _Comment, MagicNumber, Expiration_Time, _Color );
if ( ordersend > 0 )
{
//   ,    
OrderPrint();
Print( "Order ", ordersend, " was placed successfully!");
return(0);
}
//   -    
int error = GetLastError();
Print("Alignment Error! GetLastError = ", error, ", ErrorDescription =  \"", ErrorDescription( error ), "\"" );
MessageBox( "Error! GetLastError = " + error + ", ErrorDescription = \"" + ErrorDescription( error ) + "\"", 
              "Error order placing", 0x00000000 | 0x00000010 | 0x00040000 ); 
return(-1);
}

int deinit()
{
//   ,  
ObjectDelete( "Open_Price_Line" );
ObjectDelete( "Stop_Loss_Line" );
ObjectDelete( "Take_Profit_Line" );
ObjectDelete( "Expiration_Line" );
ObjectDelete( "Comment" );

for ( double z = 0.1; z <= 1; z += 0.1 )
{ ObjectDelete( DoubleToStr( z, 1 )); }
for ( z = 1; z <= 10; z ++ )
{ ObjectDelete( DoubleToStr( z, 1 )); }
ObjectDelete( "Lots" );
ObjectDelete( "Lots_value" );
ObjectDelete( ">" );
return(0);
}